/* -*- c -*- */

#define _GNU_SOURCE
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdbool.h>
#include <math.h>

#include <dlfcn.h>

static void* themonitor;
static void (*themonitor_enter)(void);
static void (*themonitor_exit)(void);

void
theinit(void)
{
    if (!getenv("THEMONITOR"))
        return;

    themonitor = dlopen(getenv("THEMONITOR"), RTLD_LAZY | RTLD_LOCAL);
    if (!themonitor)
        perror("Could not load THEMONITOR\n");

    themonitor_enter = dlsym(themonitor, "theenter");
    if (!themonitor_enter)
        perror("Could not load theenter symbol\n");

    themonitor_exit = dlsym(themonitor, "theexit");
    if (!themonitor_exit)
        perror("Could not load theexit symbol\n");
}

void
thefini(void)
{
    if (themonitor)
        dlclose(themonitor);
    themonitor = NULL;
    themonitor_enter = NULL;
    themonitor_exit = NULL;
}

void
therealone(int i)
{
    if (themonitor)
        themonitor_enter();

    printf("%d\n", i);
    sleep(1);

    if (themonitor)
        themonitor_exit();
}
